comment $
Ŀ
                                                                          
                        Fichier en tte pour 3D.ASM                       
                                                                          
Ĵ
                                                                        
                       (C) 1995, SM Karibou                             
                                                                        
Ĵ
                                                                          
 Date de cration: 18/11/95                                               
 Date de rvison : 30/11/95                                               
                                                                          

$
include filler.ash

; Table de sinu/cosinus 512 valeurs, 12bits 
;========================
GLOBAL Sine:DWORD
GLOBAL CoSine:DWORD

; Rotation 9 muls/pt 

;== Rotation autour de x,y et z. (9muls/Pt)

;== Entre: DS:ESI Coord a rotater (X,Y,Z)
;           DS:EDI Coord rotated   (X,Y,Z)
;== Arguments: AngleX,AngleY,AngleZ,Nbr de points
GLOBAL RotatePointsFast:NEAR

;== Rotation autour de z,y et x. (9muls/Pt)

;== Entre: DS:ESI Coord a rotater (X,Y,Z)
;           DS:EDI Coord rotated   (X,Y,Z)
;== Arguments: AngleX,AngleY,AngleZ,@@Nbr de points
GLOBAL RotateInvert:NEAR

; Rotation 6 muls/Pt 
;======================== Interne
GLOBAL _R:DWORD:3*3
GLOBAL __A:DWORD:3

;== Rotate des points autour de x,y et z. (6muls/pt+x muls)

;== Entre:    DS:ESI Coord a rotater (X,Y,Z,B)
;              DS:EDI Coord rotated   (X,Y,Z)

;Note: Appeler PrepareRotation avant de faire appel aux autres fonctions
;Voir arguments respectifs
GLOBAL PrepareRotation6m:NEAR
GLOBAL RotatePoints6m:NEAR

_RotatePoints6m Macro
             mov eax,_R[4]
             mov edx,[esi]
             sal edx,12
             add eax,edx
             mov ebx,_R
             mov edx,[esi+4]
             sal edx,12
             add ebx,edx
             cdq
             imul ebx
             shrd eax,edx,12
             sub eax,__a
             sub eax,[esi+12]
             mov ecx,eax
             mov eax,_R[8]
             cdq
             imul dword ptr [esi+8]
             add ecx,eax

             sar ecx,12
             mov [edi],ecx      ; X' ouf !

             mov eax,_R[16]
             mov edx,[esi]
             sal edx,12
             add eax,edx
             mov ebx,_R[12]
             mov edx,[esi+4]
             sal edx,12
             add ebx,edx
             cdq
             imul ebx
             shrd eax,edx,12
             sub eax,__a[4]
             sub eax,[esi+12]
             mov ecx,eax
             mov eax,_R[20]
             cdq
             imul dword ptr [esi+8]
             add ecx,eax

             sar ecx,12
             mov [edi+4],ecx      ; Y' ouf !

             mov eax,_R[28]
             mov edx,[esi]
             sal edx,12
             add eax,edx
             mov ebx,_R[24]
             mov edx,[esi+4]
             sal edx,12
             add ebx,edx
             cdq
             imul ebx
             shrd eax,edx,12
             sub eax,__a[8]
             sub eax,[esi+12]
             mov ecx,eax
             mov eax,_R[32]
             cdq
             imul dword ptr [esi+8]
             add ecx,eax

             sar ecx,12
             mov [edi+8],ecx      ; Z' ouf !

endm


; Rotation Additions 
A=300
GLOBAL _TriX:DWORD:A*4
GLOBAL _TriY:DWORD:A*4
GLOBAL _TriZ:DWORD:A*4

GLOBAL PrepareRotation:NEAR
GLOBAL RotatePoints:NEAR

_RotatePoints   macro
                local @@h1,@@h2,@@h3,@@e1,@@e2,@@e3
                mov eax,[esi]
                or eax,eax
                jns @@h1
                neg eax

                shl eax,4
                add eax,offset _TriX

                mov ebx,[eax]
                mov ecx,[eax+4]
                mov edx,[eax+8]

                neg ebx
                neg ecx
                neg edx
                jmp @@e1
@@h1:
                shl eax,4
                add eax,offset _TriX

                mov ebx,[eax]
                mov ecx,[eax+4]
                mov edx,[eax+8]

@@E1:
                mov eax,[esi+4]
                or eax,eax
                jns @@h2
                neg eax

                shl eax,4
                add eax,offset _TriY

                sub ebx,[eax]
                sub ecx,[eax+4]
                sub edx,[eax+8]
                jmp @@e2

@@h2:
                shl eax,4
                add eax,offset _TriY

                add ebx,[eax]
                add ecx,[eax+4]
                add edx,[eax+8]

@@e2:
                mov eax,[esi+8]
                or eax,eax
                jns @@h3
                neg eax
                shl eax,4
                add eax,offset _TriZ

                sub ebx,[eax]
                sub ecx,[eax+4]
                sub edx,[eax+8]
                jmp @@e3

@@h3:
                shl eax,4
                add eax,offset _TriZ

                add ebx,[eax]
                add ecx,[eax+4]
                add edx,[eax+8]
@@e3:
                sar ebx,16
                sar ecx,16
                sar edx,16
                mov [edi],ebx
                mov [edi+4],ecx
                mov [edi+8],edx

endm

;
;== Scaling
;== Entre: DS:ESI Liste a scaler (X,Y,Z,B)
;           EAX @@Nbr de points
;           EBP le facteur de scalage (12bits)

;           Note: Gare a la virgule fixe dans EBP !!!
GLOBAL ScalePoints:NEAR

;
;== Translation
;== Entre:    DS:ESI Liste a Translater (X,Y,Z)
;   Arguments: Tx,Ty,Tz Vecteur de translation,@@Nbr de points
GLOBAL TransPoints:NEAR

_TransPoint Macro

            add [esi],eax
            add [esi+4],ebx
            add [esi+8],ecx
endm

;
;== Projection

;== Entre: ECX Nbr Points
;           DS:ESI Liste de coord a projeter
;           DS:EDI LIste de coord Y/X projete
GLOBAL Project:NEAR
GLOBAL _PCenterX:DWORD
GLOBAL _PCenterY:DWORD
GLOBAL _XZoom:DWORD   ;= coef de zoom par rapport au 320*200
GLOBAL _YZoom:DWORD

_Project Macro
         local @@ik,@@lm,@@lm2,@@lm21,@@lm22

  mov   ebx,512
  sub   ebx,DWord Ptr [esi+8] ; recup ZCoord EBX = 512 - ZCoord
  jnz @@Ik
  inc ebx
 @@Ik:
  mov   eax,DWord Ptr [esi]   ; EAX = X coord
  shl   eax,9
  cdq
  idiv  ebx
  cdq
  imul dword ptr _XZoom
  sar eax,8
  add eax,_PCenterX                  ; AX = (XCoord*512)/(512-ZCoord)+Cx

  mov   Word Ptr [edi+2],ax

  mov   eax,DWord Ptr [esi+4] ; EAX = Y coord
  cdq
  shl   eax,9
  idiv  ebx
  cdq
  imul dword ptr _YZoom

  sar eax,8
  add   eax,_PCenterY                  ; AX = (YCoord*512)/(512-ZCoord)+Cy
  mov   Word Ptr [edi],AX

endm

;
