comment $
Ŀ
                                                                          
                            3DShell.asm                                   
                       (Shell 3d pour faciliter)                          
Ĵ
                                                                        
                       (C) 1995, SM Karibou                             
                                                                        
Ĵ
                                                                          
 Date de cration: 04/09/95                                               
 Date de rvison : 19/11/95                                               
                                                                          

$

;=============================== NOTE: Triangles Only !
.386p
locals
.MODEL FLAT,PASCAL
.DATA?

include 3d.ash
include shading.ash
include 3dshell.ash
include \asm\util.ash

; Transformation selective 

;=========================== Gouraud, Mapping, Texture Mapping

align 4
_VertxOfs dd ?       ; Offset des points 3D
_VRotOfs  dd ?       ; Offset du buffer recevant les points rotat
_ProjOfs  dd ?       ; Offset du buffer recevant les points projets
_VFaceOfs dd ?       ; Offset du buffer recevant les pointeurs sur les faces visibles
_ShadeOfs dd ?       ; Offset du buffer recevant la table d'eclairage
_VNOfs    dd ?       ; Offset des normales aux points
_VNRotOfs dd ?       ; Offset du buffer recevant les normales rotates (Phong)

_c       dd ?
_c2      dd ?

_CtrlTab	dd ?
_CtrlNbr	dd ?

MemHandle       dd ?

.CODE

InitTransform Proc Pascal Near
	      Arg @@NbrPts:DWORD

	      ;====================== Alloc Mem
	      mov edx,@@NbrPts
              Call DPMIAlloc
	      jc @@error
	      mov _CtrlTab,edx
	      mov eax,@@NbrPts
	      mov _CtrlNbr,eax
              mov MemHandle,ebx
@@error:
	      ret
InitTransform endp

UnInitTransform Proc Near
                mov ebx,MemHandle
                Call DPMIFree
		ret
UnInitTransform endp


TransformPts Proc Pascal Near
             Arg @@Xan,@@Yan,@@Zan,@@Nbr,@@DivCol:Dword

	     mov edi,_CtrlTab
             mov ecx,_CtrlNbr
             xor eax,eax
             rep stosb

             Call PrepareRotation,@@Xan,@@Yan,@@Zan
             Call PrepareShading,@@Xan,@@Yan,@@Zan,@@DivCol

             mov edi,_CtrlTab
             mov esi,_VFaceOfs
@@Loop:
             mov ebx,[esi]
             mov ebx,[ebx]

             test byte ptr [edi+ebx],1
             jnz @@Inc1
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi

             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_ShadeOfs
             add esi,_c
             add edi,_c2
             _CalcShading

             pop edi esi
@@inc1:
             mov ebx,[esi]
             mov ebx,[ebx+4]

             test byte ptr [edi+ebx],1
             jnz @@Inc2
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi

             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_ShadeOfs
             add esi,_c
             add edi,_c2

             _CalcShading

             pop edi esi
@@inc2:
             mov ebx,[esi]
             mov ebx,[ebx+8]

             test byte ptr [edi+ebx],1
             jnz @@Inc3
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi
             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_ShadeOfs
             add esi,_c
             add edi,_c2

             _CalcShading

             pop edi esi
@@inc3:
             add esi,4
             dec @@Nbr
             jnz @@loop
             ret
TransformPts endp

;=========================== Phong

TransformPts2 Proc Pascal Near
             Arg @@Xan,@@Yan,@@Zan,@@Nbr:Dword

             mov edi,_CtrlTab
             mov ecx,_CtrlNbr
             xor eax,eax
             rep stosb

             Call PrepareRotation,@@Xan,@@Yan,@@Zan

             mov edi,_CtrlTab
             mov esi,_VFaceOfs
@@Loop:
             mov ebx,[esi]
             mov ebx,[ebx]

             test byte ptr [edi+ebx],1
             jnz @@Inc1
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi
             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_VNRotOfs
             add esi,_c
             add edi,_c
             _RotatePoints

             pop edi esi
@@inc1:
             mov ebx,[esi]
             mov ebx,[ebx+4]

             test byte ptr [edi+ebx],1
             jnz @@Inc2
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi
             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_VNRotOfs
             add esi,_c
             add edi,_c
             _RotatePoints

             pop edi esi
@@inc2:
             mov ebx,[esi]
             mov ebx,[ebx+8]

             test byte ptr [edi+ebx],1
             jnz @@Inc3
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi
             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_VNRotOfs
             add esi,_c
             add edi,_c
             _RotatePoints

             pop edi esi
@@inc3:
             add esi,4
             dec @@Nbr
             jnz @@loop
             ret
TransformPts2 endp

TransformPts3 Proc Pascal Near
             Arg @@Xan,@@Yan,@@Zan,@@Nbr:Dword


             mov edi,_CtrlTab
             mov ecx,_CtrlNbr
             xor eax,eax
             rep stosb

             Call PrepareRotation,@@Xan,@@Yan,@@Zan

	         mov edi,_CtrlTab
             mov esi,_VFaceOfs
@@Loop:
             mov ebx,[esi]
             mov ebx,[ebx]

             test byte ptr [edi+ebx],1
             jnz @@Inc1
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi
             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_VNRotOfs
             add esi,_c
             add edi,_c
             mov ecx,2
             rep movsd

             pop edi esi
@@inc1:
             mov ebx,[esi]
             mov ebx,[ebx+4]

             test byte ptr [edi+ebx],1
             jnz @@Inc2
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi
             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_VNRotOfs
             add esi,_c
             add edi,_c
             mov ecx,2
             rep movsd

             pop edi esi
@@inc2:
             mov ebx,[esi]
             mov ebx,[ebx+8]

             test byte ptr [edi+ebx],1
             jnz @@Inc3
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi
             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_VNRotOfs
             add esi,_c
             add edi,_c
             mov ecx,2
             rep movsd

             pop edi esi
@@inc3:
             add esi,4
             dec @@Nbr
             jnz @@loop
             ret
TransformPts3 endp

; Les mmes mais avec translation incorpore 

TTransformPts Proc Pascal Near
             Arg @@Xan,@@Yan,@@Zan,@@Tx,@@Ty,@@Tz,@@Nbr,@@DivCol:Dword

             mov edi,_CtrlTab
             mov ecx,_CtrlNbr
             xor eax,eax
             rep stosb

             Call PrepareRotation,@@Xan,@@Yan,@@Zan
             Call PrepareShading,@@Xan,@@Yan,@@Zan,@@DivCol

             mov edi,_CtrlTab
             mov esi,_VFaceOfs
@@Loop:
             mov ebx,[esi]
             mov ebx,[ebx]

             test byte ptr [edi+ebx],1
             jnz @@Inc1
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi

             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov esi,edi
	     mov eax,@@Tx
	     mov ebx,@@Ty
	     mov ecx,@@Tz
	     _TransPoint

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_ShadeOfs
             add edi,_c2
             add esi,_c
             _CalcShading

             pop edi esi
@@inc1:
             mov ebx,[esi]
             mov ebx,[ebx+4]

             test byte ptr [edi+ebx],1
             jnz @@Inc2
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi

             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov esi,edi
	     mov eax,@@Tx
	     mov ebx,@@Ty
	     mov ecx,@@Tz
	     _TransPoint

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_ShadeOfs
             add edi,_c2
             add esi,_c
             _CalcShading

             pop edi esi
@@inc2:
             mov ebx,[esi]
             mov ebx,[ebx+8]

             test byte ptr [edi+ebx],1
             jnz @@Inc3
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi
             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov esi,edi
   	     mov eax,@@Tx
	     mov ebx,@@Ty
	     mov ecx,@@Tz
	     _TransPoint

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_ShadeOfs
             add edi,_c2
             add esi,_c
             _CalcShading

             pop edi esi
@@inc3:
             add esi,4
             dec @@Nbr
             jnz @@loop

             ret
TTransformPts endp

;=========================== Phong

TTransformPts2 Proc Pascal Near
             Arg @@Xan,@@Yan,@@Zan,@@TX,@@Ty,@@TZ,@@Nbr:Dword

             mov edi,_CtrlTab
             mov ecx,_CtrlNbr
             xor eax,eax
             rep stosb

             Call PrepareRotation,@@Xan,@@Yan,@@Zan

             mov edi,_CtrlTab
             mov esi,_VFaceOfs
@@Loop:
             mov ebx,[esi]
             mov ebx,[ebx]

             test byte ptr [edi+ebx],1
             jnz @@Inc1
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi
             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov esi,edi
	         mov eax,@@Tx
	         mov ebx,@@Ty
	         mov ecx,@@Tz
	         _TransPoint

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_VNRotOfs
             add esi,_c
             add edi,_c
             _RotatePoints

             pop edi esi
@@inc1:
             mov ebx,[esi]
             mov ebx,[ebx+4]

             test byte ptr [edi+ebx],1
             jnz @@Inc2
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi
             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov esi,edi
	         mov eax,@@Tx
	         mov ebx,@@Ty
	         mov ecx,@@Tz
	         _TransPoint

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_VNRotOfs
             add esi,_c
             add edi,_c
             _RotatePoints

             pop edi esi
@@inc2:
             mov ebx,[esi]
             mov ebx,[ebx+8]

             test byte ptr [edi+ebx],1
             jnz @@Inc3
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi
             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov esi,edi
	         mov eax,@@Tx
	         mov ebx,@@Ty
	         mov ecx,@@Tz
	         _TransPoint

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_VNRotOfs
             add esi,_c
             add edi,_c
             _RotatePoints

             pop edi esi
@@inc3:
             add esi,4
             dec @@Nbr
             jnz @@loop
             ret
TTransformPts2 endp

TTransformPts3 Proc Pascal Near
             Arg @@Xan,@@Yan,@@Zan,@@TX,@@TY,@@TZ,@@Nbr:Dword


             mov edi,_CtrlTab
             mov ecx,_CtrlNbr
             xor eax,eax
             rep stosb

             Call PrepareRotation,@@Xan,@@Yan,@@Zan

	         mov edi,_CtrlTab
             mov esi,_VFaceOfs
@@Loop:
             mov ebx,[esi]
             mov ebx,[ebx]

             test byte ptr [edi+ebx],1
             jnz @@Inc1
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi
             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov esi,edi
	         mov eax,@@Tx
	         mov ebx,@@Ty
	         mov ecx,@@Tz
	         _TransPoint

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_VNRotOfs
             add esi,_c
             add edi,_c
             mov ecx,2
             rep movsd

             pop edi esi
@@inc1:
             mov ebx,[esi]
             mov ebx,[ebx+4]

             test byte ptr [edi+ebx],1
             jnz @@Inc2
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi
             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov esi,edi
	         mov eax,@@Tx
	         mov ebx,@@Ty
	         mov ecx,@@Tz
	         _TransPoint

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_VNRotOfs
             add esi,_c
             add edi,_c
             mov ecx,2
             rep movsd

             pop edi esi
@@inc2:
             mov ebx,[esi]
             mov ebx,[ebx+8]

             test byte ptr [edi+ebx],1
             jnz @@Inc3
             mov byte ptr [edi+ebx],1
             mov _c2,ebx

             push esi edi
             mov esi,_VertxOfs
             mov edi,_VRotOfs

             mov edx,ebx
             shl ebx,4
             shl edx,2
             sub ebx,edx
             add esi,ebx
             add edi,ebx
             mov _c,ebx
             _RotatePoints

             mov esi,edi
	         mov eax,@@Tx
	         mov ebx,@@Ty
	         mov ecx,@@Tz
	         _TransPoint

             mov ebx,_c2
             mov esi,edi
             mov edi,_ProjOfs
             shl ebx,2
             add edi,ebx
             _Project

             mov esi,_VNOfs
             mov edi,_VNRotOfs
             add esi,_c
             add edi,_c
             mov ecx,2
             rep movsd

             pop edi esi
@@inc3:
             add esi,4
             dec @@Nbr
             jnz @@loop
             ret
TTransformPts3 endp
END


