comment $
Ŀ
                                                                          
                          		Backface.Asm                       
                    (Routines de gestion des faces caches)               
Ĵ
                                                                        
                       (C) 1995, SM Karibou                             
                                                                        
Ĵ
                                                                          
 Date de cration: --/--/--                                               
 Date de rvison : 04/05/96                                               
                                                                          

$

;============================= ATTENTION : Triangle Only !
.386p
locals
.MODEL FLAT,PASCAL
.CODE
include backface.ash
include 3d.ash
include \asm\util.ash

;============= Clipping Paralelipedik avant transfiormation daubik, mais bon. :)
CLIPX=300
CLIPZ=300
CLIPY=300

;
;= Entre:
;=        DS:ESI        Liste de faces
;=        DS:EDI        Tablo recevant les pointeurs sur les faces visibles
;=        DS:_PtsOfs    Pointeur sur les points 3D
;=        DS:_NFofs     Pointeur sur les normales aux faces
;=
;=      Ax,Ay,Az,TX,Ty,TZ,Nbr

;= Sortie:
;=        _FacesVisibles= nbr de faces visibles

.DATA?
align 4
_FacesVisibles   dd  ?

_PtsOfs         dd ?
_NFOfs          dd ?
_x              dd ?
_y              dd ?
_z              dd ?
_z2             dd ?
_z3             dd ?
_v1             dd ?

_RViewPoint     dd ?,?,?

.DATA
_ViewPoint      dd 0,0,4096      ;= Position du point de vue

.CODE
RemoveHiddenFaces Proc Pascal near
                  Arg @@Xan,@@Yan,@@Zan,@@tX,@@Ty,@@Tz,@@Nbr:DWord

                  mov _FacesVisibles,0

                  push esi
                  push edi

                  lea esi,_ViewPoint
                  lea edi,_RViewPoint

                  mov eax,512
                  sub eax,@@Xan
                  and eax,511
                  push eax

                  mov eax,512
                  sub eax,@@Yan
                  and eax,511
                  push eax

                  mov eax,512
                  sub eax,@@Zan
                  and eax,511
                  push eax
                  push 1
                  Call RotateInvert

                  pop edi
                  pop esi

                  mov ecx,_PtsOfs
@@Loop:
                  mov ebx,[esi]

                  mov eax,ebx
                  shl ebx,4
                  shl eax,2
                  sub ebx,eax

                  ;======================== 1 Point de la face
                  mov eax,[ecx+ebx]
                  mov _x,eax

                  add eax,@@TX
                  cmp eax,CLIPX
                  jg @@Hidden
                  cmp eax,-CLIPX
                  jl @@Hidden


                  mov eax,[ecx+ebx+4]
                  mov _y,eax

                  add eax,@@TY
                  cmp eax,CLIPY
                  jg @@Hidden
                  cmp eax,-CLIPY
                  jl @@Hidden

                  mov eax,[ecx+ebx+8]
                  mov _z,eax

                  add eax,@@TZ
                  cmp eax,CLIPZ
                  jg @@Hidden
                  cmp eax,-CLIPZ
                  jl @@Hidden

comment $
                  ;=========== Finaklement 1 second point s'impose
                  mov ebx,[esi+4]

                  mov eax,ebx
                  shl ebx,4
                  shl eax,2
                  sub ebx,eax

                  mov eax,[ecx+ebx]
                  add eax,@@TX
                  cmp eax,CLIPX
                  jg @@Hidden
                  cmp eax,-CLIPX
                  jl @@Hidden


                  mov eax,[ecx+ebx+4]
                  add eax,@@TY
                  cmp eax,CLIPY
                  jg @@Hidden
                  cmp eax,-CLIPY
                  jl @@Hidden

                  mov eax,[ecx+ebx+8]
                  add eax,@@TZ
                  mov _z2,eax
                  cmp eax,CLIPZ
                  jg @@Hidden
                  cmp eax,-CLIPZ
                  jl @@Hidden

                  ;=========== Voir un troisieme
                  mov ebx,[esi+8]

                  mov eax,ebx
                  shl ebx,4
                  shl eax,2
                  sub ebx,eax

                  mov eax,[ecx+ebx]
                  add eax,@@TX
                  cmp eax,CLIPX
                  jg @@Hidden
                  cmp eax,-CLIPX
                  jl @@Hidden


                  mov eax,[ecx+ebx+4]
                  add eax,@@TY
                  cmp eax,CLIPY
                  jg @@Hidden
                  cmp eax,-CLIPY
                  jl @@Hidden

                  mov eax,[ecx+ebx+8]
                  add eax,@@TZ
                  mov _z3,eax
                  cmp eax,CLIPZ
                  jg @@Hidden
                  cmp eax,-CLIPZ
                  jl @@Hidden

                  ;===================== Test a chier de clip en Z
                  mov eax,_z
                  add eax,_z2
                  add eax,_z3
                  cmp eax,600
                  jg @@Hidden
$
                  mov ebx,_NFofs

                  mov eax,_x
                  sub eax,_RViewPoint[0]
                  cdq
                  imul dword ptr [ebx]
                  mov _v1,eax

                  mov eax,_y
                  sub eax,_RViewPoint[4]
                  cdq
                  imul dword ptr [ebx+4]
                  add _v1,eax

                  mov eax,_z
                  sub eax,_RViewPoint[8]
                  cdq
                  imul dword ptr [ebx+8]
                  add _v1,eax
                  js @@hidden

                  mov [edi],esi
                  add edi,4
                  inc _FacesVisibles
@@Hidden:
                  add esi,4*4
                  add _NFOfs,4*3
                  dec @@Nbr
                  jnz @@Loop

                  ret
RemoveHiddenFaces Endp

;

;= Macro Utilise pour le Sort
RecupIndex Macro

          ;======== Recupere Index de Tri
          push ebp
          shl ebx,2
          mov ebx,[esi+ebx]
          mov eax,[ebx]     ;=== Recupere numeros de points
          mov ecx,[ebx+4]
          mov edx,[ebx+8]

          mov ebx,eax
          mov ebp,eax
          shl ebx,3
          shl ebp,2
          add ebx,ebp
          mov eax,[edi+ebx+8]  ;=== Recupere Z du 1er point

          mov ebx,ecx
          mov ebp,ecx
          shl ebx,3
          shl ebp,2
          add ebx,ebp
          add eax,[edi+ebx+8]  ;=== Recupere Z du 2eme point

          mov ebx,edx
          mov ebp,edx
          shl ebx,3
          shl ebp,2
          add ebx,ebp
          add eax,[edi+ebx+8]  ;=== Recupere Z du 3eme point

         pop ebp
endm

Getz2 Macro

          ;======== Recupere Index de Tri
          push ebp
          ;shl ebx,2
          ;mov ebx,[esi+ebx]
          mov eax,[ebx]     ;=== Recupere numeros de points
          mov ecx,[ebx+4]
          mov edx,[ebx+8]

          mov ebx,eax
          mov ebp,eax
          shl ebx,3
          shl ebp,2
          add ebx,ebp
          mov eax,[edi+ebx+8]  ;=== Recupere Z du 1er point

          mov ebx,ecx
          mov ebp,ecx
          shl ebx,3
          shl ebp,2
          add ebx,ebp
          add eax,[edi+ebx+8]  ;=== Recupere Z du 2eme point

          mov ebx,edx
          mov ebp,edx
          shl ebx,3
          shl ebp,2
          add ebx,ebp
          add eax,[edi+ebx+8]  ;=== Recupere Z du 3eme point

         pop ebp
endm

;

;==== Radix Sort :)))

;= Entre:
;=        DS:ESI : Pointeurs sur le tablo des faces visibles
;=        DS:EDI : Pointeurs sur les points
;= Sortie:
;=        ecx : nombre de faces maintenat visibles
comment $
.DATA?
MemHandle       dd ?
align 4
pile:
REPT 32
     dd ?,?
endm

align 4
depile:
REPT 32
     dd ?
endm

.CODE

InitSort Proc Pascal Near
	 Arg @@_NbrFaces:Dword

	 ;====================== Allocation dynamik des piles
	 mov edx,@@_NbrFaces
	 add edx,2  ;= Compte le -1 et la face 0

	 shl edx,2
	 mov ecx,edx
         shl edx,5
         Call DPMIAlloc
	 jc @@error
         mov MemHandle,ebx

	 mov esi,offset pile+8*15
         mov edi,offset depile
	 mov eax,16
@@loop:
	 mov dword ptr [edx],-1
	 mov [esi],edx
	 mov [esi+4],edx
	 mov [edi],edx

	 add edi,4
	 sub esi,8
	 add edx,ecx
	 dec eax
	 jnz @@loop

	 mov esi,offset pile+8*16
	 mov edi,offset depile+4*16
	 mov eax,16
@@loop2:
	 mov dword ptr [edx],-1
	 mov [esi],edx
	 mov [esi+4],edx
	 mov [edi],edx

         add edi,4
         add esi,8
	 add edx,ecx
	 dec eax
	 jnz @@loop2
	 clc
@@error:
	 ret
InitSort endp

UnInitSort Proc Near
           mov ebx,MemHandle
           Call DPMIFree
	   ret
UnInitSort endp

RadixSort Proc Pascal Near
          Arg @@_end:Dword
          local @@divisor,@@i,save,save2:Dword

          mov save,esi
          mov save2,edi

          mov @@divisor,0
@@While1:
          cmp @@divisor,4*8
          je @@EndWhile1
          mov @@i,0
@@For:
          mov ebx,@@i
          mov edi,save2
          RecupIndex
          or eax,eax
          js @@sign

          mov ecx,@@divisor
          shr eax,cl
          and eax,0fh

          mov edi,dword ptr pile[eax*8+16*8]
          add dword ptr pile[eax*8+16*8],4
          mov dword ptr [edi+4],-1
          jmp @@ok
@@Sign:
          neg eax

          mov ecx,@@divisor
          shr eax,cl
          and eax,0fh

          mov edi,dword ptr pile[eax*8]
          add dword ptr pile[eax*8],4
          mov dword ptr [edi+4],-1
@@ok:
          mov ebx,@@i
          shl ebx,2
          mov eax,dword ptr [esi+ebx]
          mov [edi],eax
          inc @@i
          mov eax,@@_end
          cmp @@i,eax
          jna @@for

          mov @@i,0
@@For2:
          mov ebx,@@i
          mov edi,dword ptr depile[ebx*4]
@@While:
          cmp dword ptr [edi],-1
          je @@EndWhile
          mov eax,[edi]
          add edi,4
          mov [esi],eax
          add esi,4
          jmp @@While
@@EndWhile:
          mov edi,dword ptr pile[ebx*8+4]        ;= remise en etat d'une pile pas de la pile courante
          mov dword ptr pile[ebx*8],edi

          mov edi,dword ptr depile[ebx*4]
          mov dword ptr [edi],-1

          inc @@i
          test @@i,32
          jz @@For2
          mov esi,save
          add @@divisor,4
          jmp @@While1
@@EndWhile1:

          ret
RadixSort endp
$
;comment $
.DATA?
MemHandle       dd ?
buff dd ?
Tab  dd 512 dup(?)

.CODE
InitSort Proc Pascal Near
	 Arg @@_NbrFaces:Dword

	 mov edx,@@_NbrFaces
	 shl edx,2

         Call DPMIAlloc
	 jc @@error
         mov MemHandle,ebx
         mov buff,edx
         clc
@@error:
	 ret
InitSort endp

UnInitSort Proc Near
           mov ebx,MemHandle
           Call DPMIFree
	   ret
UnInitSort endp

RadixSort Proc Near
          Arg @@_end:Dword
          local save,save2:Dword

          mov save,esi
          mov save2,edi

          ;============= Init tablo
          lea edi,tab
          mov ecx,512
          xor eax,eax
          rep stosd

          ;============= comptage
          mov ebx,@@_end
          mov esi,save
          mov edi,save2
@@l1:
          push ebx
          RecupIndex
          pop  ebx

          xor ecx,ecx
          mov cl,al
          xchg ah,al
          and eax,0ffh
          inc tab[ecx*4]
          inc tab[eax*4+256*4]
          dec ebx
          jns @@L1

          ;============== recup
          mov ecx,511
          mov eax,@@_end
          inc eax
          sub tab[255*4],eax
          mov ebx,eax
@@l2:
          sub ebx,tab[ecx*4]
          mov tab[ecx*4],ebx

          dec ecx
          jns @@l2

          ;============= Calcul des ajusteurs
          push ebp
          mov edx,@@_end
          inc edx
          mov ebp,tab[384*4]
          sub edx,ebp
          neg ebp

          ;============ Ajustement pour les signes
          mov ebx,128
          mov ecx,256*4
@@l3:
          add tab[ecx],edx
          add tab[ecx+128*4],ebp

          add ecx,4
          dec ebx
          jnz @@l3
          pop ebp

          ;============= Triiiiiiiiiiiiiiii
          ;============= Poids faible
          xor ebx,ebx
          inc @@_end
@@l4:
          mov esi,save
          mov edi,save2
          push ebx
          RecupIndex
          pop ebx

          and eax,0ffh

          shl eax,2
          mov ecx,tab[eax]
          inc tab[eax]

          mov edx,buff
          mov eax,[esi+ebx*4]         ;= save du pointeur sur la face
          mov [edx+ecx*4],eax

          inc ebx
          cmp ebx,@@_end
          jne @@l4

          ;=================== Poids fort
          xor ecx,ecx
@@l5:
          mov esi,buff
          mov ebx,[esi+ecx*4]
          mov edi,save2
          push ecx
          GetZ2
          pop ecx

          xchg ah,al
          and eax,0ffh
          shl eax,2
          mov ebx,tab[eax+256*4]
          inc tab[eax+256*4]

          mov edi,buff
          mov esi,save
          mov edx,[edi+ecx*4]
          mov [esi+ebx*4],edx

          inc ecx
          cmp ecx,@@_end
          jne @@l5
comment $
          ;=========== Ajuste Valeur _FaceVisibles en fct du Clipping Z
          xor ecx,ecx
          mov esi,save
          mov edi,save2
@@lz:
          mov ebx,[esi]
          push ecx
          GetZ2
          pop ecx

          cmp eax,600
          jg @@GetOut

          add esi,4
          inc ecx
          cmp ecx,@@_end
          jne @@lz
@@getOut:
         $
          ret
RadixSort endp

;
END
